import { AfterViewInit, ElementRef, OnDestroy, OnInit, ViewContainerRef, WritableSignal } from '@angular/core';
import { ComponentBaseProps, ComponentConfig, Size, Tick, TooltipPosition } from 'ngx-puzzle/core/interfaces';
import * as i0 from "@angular/core";
export declare class NgxPuzzleCanvasComponent implements OnInit, AfterViewInit, OnDestroy {
    hRuler: ElementRef<HTMLElement>;
    vRuler: ElementRef<HTMLElement>;
    canvasContent: ViewContainerRef;
    canvasContainer: ElementRef<HTMLElement>;
    private destroy$;
    private _config;
    private selectedId;
    private injector;
    private registry;
    private mediator;
    private renderer;
    props: WritableSignal<ComponentBaseProps>;
    positionSignal: WritableSignal<TooltipPosition>;
    horizontalCursorStyle: import("@angular/core").Signal<{
        left: string;
        width: string;
    }>;
    verticalCursorStyle: import("@angular/core").Signal<{
        top: string;
        height: string;
    }>;
    horizontalLabels: import("@angular/core").Signal<{
        left: number;
        right: number;
    }>;
    verticalLabels: import("@angular/core").Signal<{
        top: number;
        bottom: number;
    }>;
    showGuideSignal: WritableSignal<boolean>;
    hTicks: WritableSignal<Tick[]>;
    vTicks: WritableSignal<Tick[]>;
    set size(size: Size);
    set config(value: ComponentConfig);
    get config(): ComponentConfig;
    constructor();
    ngOnInit(): void;
    ngAfterViewInit(): void;
    private setupObservables;
    private updateRulers;
    private updateRulerPosition;
    private generateTicks;
    private renderAll;
    private createComponent;
    private covertPosition;
    canvasHandleSelect(event: MouseEvent): void;
    ngOnDestroy(): void;
    static ɵfac: i0.ɵɵFactoryDeclaration<NgxPuzzleCanvasComponent, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<NgxPuzzleCanvasComponent, "ngx-puzzle-canvas, puzzle-canvas", never, {}, {}, never, never, true, never>;
}
